#include "struct.h"
#include "fproto.h"

int  EffortNum, VgNum, StmtsNum, CmntsNum;
extern int cmtflg;

void prn_file_proc(fptr)
FILE *fptr;
{
  FILENODE *fltemp;
  MODNODE *mdtemp;

        int i;

	FILENODE *RootFile,*CurrentFile;
        MODNODE *CurrentModule;       

        get_prn_offset(fptr);

	RootFile = CurrentFile = NULL;
	CurrentModule = NULL;

	Fill_Struct(fptr,&RootFile);

        cal_mi(RootFile);
	 
}

Fill_Struct(fptr, RootFile)
FILE *fptr;
FILENODE **RootFile;
{
        FILENODE *CurrentFile=NULL;
        MODNODE *CurrentModule=NULL;
	int counter = 0;
	char c1,c2;
	char s3[5];
	float *num;
	int NO=24;
	int i=0;
	char procname[10],filename[100],tempstr[5];

	num = (float *)malloc((NO + 1)*sizeof(float));

while (!feof(fptr))
{
	procname[0] = '\0';
	fscanf(fptr," \"%[^\"]s",&procname);
	fscanf(fptr,"%c%c",&c1,&c2);
	
	num[0] = 0.0;

	for(counter = 1; counter <= NO; counter++)
		num[counter] = 0.0;
	
	/*for(counter = 1; counter <= NO; counter++)
		fscanf(fptr,"%f,",&(num[counter]));*/
       
	counter = 1;
        while (fscanf(fptr,"%f,",&(num[counter])))
	{
	   counter++;
        }

	filename[0] = '\0';
	fscanf(fptr," \"%[^\"]s",&filename);
	fscanf(fptr,"%c%c",&c1,&c2);

	if (CurrentFile == NULL)
	{
		CurrentFile = *RootFile = (FILENODE *)malloc(sizeof(FILENODE));
		strcpy(CurrentFile->file_name,filename);
		CurrentFile->no_of_modules = 0;
		CurrentFile->mod_node = NULL;
		CurrentFile->next_file = NULL;
	}
	if(!(strcmp(CurrentFile->file_name,filename)))
	{
		if(CurrentModule == NULL)
		{
			CurrentModule = (MODNODE *)malloc(sizeof(MODNODE));
			CurrentFile->mod_node = CurrentModule;
		}
		else
		{
			CurrentModule->next = (MODNODE *)malloc(sizeof(MODNODE));
			CurrentModule = CurrentModule->next;
		}
	}	
	else
	{
		CurrentFile->next_file = (FILENODE *)malloc(sizeof(FILENODE));
		CurrentFile = CurrentFile->next_file;
		CurrentFile->no_of_modules = 0;
		CurrentFile->next_file = NULL;
		strcpy(CurrentFile->file_name,filename);
		CurrentModule = CurrentFile->mod_node = (MODNODE *)malloc(sizeof(MODNODE));
	}
	CurrentModule->next = NULL;
	CurrentModule->mod_data[0] =(long int) num[EffortNum];
	CurrentModule->mod_data[1] =(long int)num[VgNum];
	CurrentModule->mod_data[2] =(long int) num[StmtsNum];
	CurrentModule->mod_data[3] =(long int) num[CmntsNum];
	CurrentFile->no_of_modules++;
	CurrentFile->total_e += CurrentModule->mod_data[0];
	CurrentFile->total_vg2 += CurrentModule->mod_data[1];
	CurrentFile->total_loc += CurrentModule->mod_data[2];
	CurrentFile->total_cmt += CurrentModule->mod_data[3];

	if (CurrentModule->mod_data[2] == 0)
	{
	   fprintf(stderr,"For File : %s",CurrentFile->file_name);
	   err_msg_disp("Lines of code for some module = 0");
	   err_msg_disp("Unable to calculate percentage comments");
           err_msg_disp("Aborting");
	   exit(1);
        }

	CurrentModule->mi = m_index((double) CurrentModule->mod_data[3]/CurrentModule->mod_data[2], CurrentModule->mod_data[0], CurrentModule->mod_data[1], CurrentModule->mod_data[2]);

	if ((c1 = fgetc(fptr)) != EOF)
           ungetc(c1,fptr);

}
}



