#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define MAX_FILE_NAME_SIZE 156
#define PRN 'p'
#define RPX 'r'

/****** Define double linked list for accessing E,VG2,LOC,CMT *****/
struct char_list {
   char datum;
   struct char_list *prev;
   struct char_list *next;
};
/*****************************************************************/

/****** Structure for storing metric data for each module    *****/
struct module_data {
   int mod_data[4];
   int mi;
   struct module_data *next;
};
/*****************************************************************/


/****** Structure to mark beginning for each file ***************/
struct file_data {
   char file_name[MAX_FILE_NAME_SIZE];
   int no_of_modules;
   int total_e;
   int total_vg2;
   int total_loc;
   int total_cmt;
   int file_mi;
   struct module_data *mod_node;
   struct file_data *next_file;
};
/*****************************************************************/


typedef struct char_list NODE;
typedef struct file_data FILENODE;
typedef struct module_data MODNODE;





