
# line 4 "ansic.y"
/******************************************************************
	Module Name: ansic.y

	Standard ANSI C Parser from Second Edition of
	"The C Programming Language"
	by Brian W. Kernighan & Dennis M. Ritchie

	Programmer: Xiaokang Yu
	Date: March 2, 1992
******************************************************************/
#define ERROR(x) yywhere(), fputs(x,stderr);
#include "where_in_code.h"

int where_in_code = WHERE_GLOBAL;

#ifdef __cplusplus
#  include <stdio.h>
#  include <yacc.h>
#endif	/* __cplusplus */ 
# define AUTO 257
# define BREAK 258
# define CASE 259
# define CHAR 260
# define CONST 261
# define CONTINUE 262
# define DEFAULT 263
# define DO 264
# define DOUBLE 265
# define ELSE 266
# define ENUM 267
# define EXTERN 268
# define FLOAT 269
# define FOR 270
# define GOTO 271
# define IF 272
# define INT 273
# define LONG 274
# define REGISTER 275
# define RETURN 276
# define SHORT 277
# define SIGNED 278
# define SIZEOF 279
# define STATIC 280
# define STRUCT 281
# define SWITCH 282
# define TYPEDEF 283
# define UNION 284
# define UNSIGNED 285
# define VOID 286
# define VOLATILE 287
# define WHILE 288
# define IDENTIFIER 289
# define CONSTANT 290
# define STRING 291
# define ASSIGN_OP 292
# define EQUALITY_OP 293
# define RELATIONAL_OP 294
# define SHIFT_OP 295
# define INCREMENT 296
# define DECREMENT 297
# define OR 298
# define AND 299
# define INDIRECT_SELECTION 300
# define ELIPSIS 301
# define TYPEDEF_NAME 302
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 669 "ansic.y"


#include "flag.h"
#include "lex.yy.c"

/*     main

       input     : stdin.
       output    : stdout.
       calls     : set_up_modules, yyparse, end_of_parse.

       This procedure starts the parsing process.
*/

main()
{
  set_up_modules();
  yyparse();
  end_of_parse();
  
  exit(0);
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 42,
	258, 159,
	259, 159,
	262, 159,
	263, 159,
	264, 159,
	270, 159,
	271, 159,
	272, 159,
	276, 159,
	279, 159,
	282, 159,
	288, 159,
	289, 159,
	290, 159,
	291, 159,
	296, 159,
	297, 159,
	59, 159,
	123, 159,
	40, 159,
	42, 159,
	38, 159,
	43, 159,
	45, 159,
	126, 159,
	33, 159,
	-2, 0,
-1, 44,
	59, 56,
	44, 56,
	-2, 9,
-1, 62,
	260, 42,
	261, 42,
	265, 42,
	267, 42,
	269, 42,
	273, 42,
	274, 42,
	277, 42,
	278, 42,
	281, 42,
	284, 42,
	285, 42,
	286, 42,
	287, 42,
	302, 42,
	-2, 0,
-1, 65,
	289, 74,
	-2, 0,
-1, 71,
	258, 156,
	259, 156,
	262, 156,
	263, 156,
	264, 156,
	270, 156,
	271, 156,
	272, 156,
	276, 156,
	279, 156,
	282, 156,
	288, 156,
	289, 156,
	290, 156,
	291, 156,
	296, 156,
	297, 156,
	59, 156,
	123, 156,
	40, 156,
	42, 156,
	38, 156,
	43, 156,
	45, 156,
	126, 156,
	33, 156,
	-2, 0,
-1, 76,
	279, 57,
	289, 57,
	290, 57,
	291, 57,
	296, 57,
	297, 57,
	123, 57,
	40, 57,
	42, 57,
	38, 57,
	43, 57,
	45, 57,
	126, 57,
	33, 57,
	-2, 0,
-1, 152,
	258, 179,
	259, 179,
	262, 179,
	263, 179,
	264, 179,
	270, 179,
	271, 179,
	272, 179,
	276, 179,
	279, 179,
	282, 179,
	288, 179,
	289, 179,
	290, 179,
	291, 179,
	296, 179,
	297, 179,
	59, 179,
	123, 179,
	40, 179,
	42, 179,
	38, 179,
	43, 179,
	45, 179,
	126, 179,
	33, 179,
	-2, 0,
-1, 225,
	125, 85,
	44, 85,
	-2, 0,
-1, 329,
	59, 69,
	44, 69,
	-2, 0,
	};
# define YYNPROD 302
# define YYLAST 2662
__YYSCLASS yytabelem yyact[]={

   137,   261,   159,   224,     5,   158,   328,   321,   147,   160,
    80,    44,    93,    70,     6,     6,   169,   167,   213,   175,
    59,   174,   173,   259,    53,    54,    55,   203,    15,    65,
   107,   214,    62,    13,   392,   102,    15,    95,    13,   103,
   104,   310,   105,   313,   225,   404,   403,   451,   399,   188,
   308,   249,   388,   372,    82,   189,   374,   246,   223,   252,
   112,    94,   428,   242,   165,   214,   119,   225,    88,    16,
    13,   245,    22,    33,   309,   133,    15,    27,    13,    36,
    19,    26,   215,   307,   248,    24,    25,    17,   163,    23,
    28,   225,    18,    37,   330,    20,    38,    29,    21,    34,
   187,   130,   336,   206,   183,   237,   208,   193,   196,    94,
   200,   250,   198,   314,    30,    15,   215,    13,   240,   238,
   127,   217,   204,   106,   210,    22,    33,   122,   218,   335,
    27,    86,    36,   409,    26,     9,    90,   230,    24,    25,
   334,    87,    23,    28,    50,   118,    37,    91,    82,    38,
    29,    21,    34,    84,   370,    94,   233,   181,    15,    85,
    13,   170,    66,   216,   326,    63,   255,    30,   262,   133,
   227,   219,   221,    76,   128,   319,   265,    45,    94,    94,
    94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
    94,   287,   289,   291,   306,    67,   301,    89,    61,   125,
   222,   136,    47,    43,   183,    92,    76,   171,   416,   415,
   183,   462,   385,   443,   408,   237,   360,   237,    82,    59,
   237,   338,   237,   119,   329,    94,   323,   166,   119,   230,
   450,   316,   431,   340,   366,    43,   344,   407,   334,    49,
   349,   275,   352,   346,   354,   355,   367,   348,   359,   350,
   389,   353,   168,   312,   258,   358,   253,    22,    33,   214,
   320,    13,    27,   362,    36,   365,    26,   184,   373,   262,
    24,    25,   343,   247,    23,    28,   100,    14,    37,   243,
    14,    38,    29,    21,    34,    14,   108,   109,   111,    33,
   220,   107,   331,    97,    98,   211,   102,   337,    95,    30,
   103,   104,   271,   105,    94,   191,   192,   369,   251,   190,
   215,   279,   119,   273,    14,    34,   316,   371,   207,   333,
    82,   318,   267,   281,   298,    14,   381,    94,   378,   269,
   226,    60,   119,    82,   241,   239,   228,   205,   391,    82,
    94,   390,   123,   395,   397,   325,    94,   393,    50,   325,
   298,   320,    13,    52,   298,   315,    13,   299,   300,   311,
   296,   342,   235,    68,    14,     8,   406,   264,   209,   410,
   412,   277,   317,   184,    48,   215,    94,    94,    94,    57,
   414,   413,   283,   285,   106,   232,    15,   176,    13,   177,
   469,    82,   329,   237,   419,    69,     4,     4,    94,   420,
   423,   215,   140,   387,    51,   215,    71,    14,    40,   237,
   427,   435,   418,   237,   430,   262,   433,    78,   386,   417,
   401,   384,   120,   438,   361,   439,   440,   441,   236,   383,
   376,   458,    77,   180,   237,   375,   442,   172,   178,   161,
   447,   449,   294,   179,   293,   453,   456,    74,   452,   237,
   445,   237,   461,   237,   124,   463,   464,   113,   466,   460,
   402,   110,   400,   237,   132,   237,   470,   132,   471,   472,
   398,   131,   303,   237,   474,    60,    16,   101,   295,    22,
    33,   237,    99,    96,    27,   212,    36,    19,    26,     2,
   368,    39,    24,    25,    17,    83,    23,    28,   257,    18,
    37,   356,    20,    38,    29,    21,    34,   473,    14,   467,
   465,   468,   454,   455,   182,   457,   444,   244,    22,    33,
   426,    30,   425,    27,   424,    36,   437,    26,   422,    72,
   134,    24,    25,    42,   143,    23,    28,   100,   380,    37,
   142,   141,    38,    29,    21,    34,   139,   108,   109,   111,
   297,   138,   364,   116,    97,    98,    56,   132,   114,   129,
    30,    64,   327,   162,   260,   164,   126,    16,    35,    32,
    22,    33,    31,    10,    46,    27,    75,    36,    19,    26,
   212,    41,     3,    24,    25,    17,     1,    23,    28,     0,
    18,    37,     0,    20,    38,    29,    21,    34,     0,     0,
     0,     0,     7,    16,     0,     0,    22,    33,     0,     0,
     0,    27,    30,    36,    19,    26,     0,     0,     0,    24,
    25,    17,     0,    23,    28,     0,    18,    37,     0,    20,
    38,    29,    21,    34,   107,    14,     0,     0,     0,   102,
     0,    95,     0,   103,   104,     0,   105,     0,    30,     0,
     0,     0,     0,     0,     0,     0,   107,     0,     0,     0,
   148,   102,     0,    95,   297,   103,   104,     0,   105,     0,
     0,     0,   115,    16,     0,     0,    22,    33,     0,     0,
     0,    27,   148,    36,    19,    26,     0,     0,     0,    24,
    25,    17,     0,    23,    28,     0,    18,    37,     0,    20,
    38,    29,    21,    34,   107,   117,     0,     0,     0,   102,
     0,    95,     0,   103,   104,     0,   105,     0,    30,     0,
     0,     0,     0,     0,    43,     0,   339,   106,     0,     0,
   148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    43,     0,   229,   106,
     0,     0,     0,   382,    16,     0,     0,    22,    33,     0,
     0,     0,    27,     0,    36,    19,    26,     0,     0,     0,
    24,    25,    17,     0,    23,    28,     0,    18,    37,     0,
    20,    38,    29,    21,    34,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    43,     0,     0,   106,     0,    30,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   107,     0,     0,     0,     0,   102,     0,    95,     0,   103,
   104,     0,   105,     0,     0,    11,     0,     0,     0,     0,
     0,     0,   107,     0,     0,     0,   148,   102,    43,    95,
     0,   103,   104,     0,   105,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   231,   148,   156,
   145,     0,     0,   155,   146,   152,     0,     0,     0,     0,
     0,   153,   154,   149,     0,     0,     0,   157,     0,   231,
   100,   156,   145,   150,     0,   155,   146,   152,     0,   151,
   144,   109,   111,   153,   154,   149,     0,    97,    98,   157,
    43,     0,   100,   106,     0,   150,     0,     0,     0,     0,
     0,   151,   144,   109,   111,     0,     0,     0,     0,    97,
    98,   185,    43,     0,     0,   106,     0,   396,     0,   156,
   145,     0,     0,   155,   146,   152,     0,     0,     0,     0,
     0,   153,   154,   149,     0,     0,     0,   157,     0,     0,
   100,   185,   185,   150,     0,     0,     0,     0,     0,   151,
   144,   109,   111,     0,     0,     0,   135,    97,    98,     0,
     0,     7,    16,     0,     0,    22,    33,     0,     0,     0,
    27,     0,    36,    19,    26,     0,     0,     0,    24,    25,
    17,     0,    23,    28,     0,    18,    37,     0,    20,    38,
    29,    21,    34,     0,    73,     0,     0,     0,     0,     0,
     0,   185,   185,     0,     0,     0,     0,    30,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   185,     0,     0,
     0,     0,     0,   345,     0,   156,   145,     0,     0,   155,
   146,   152,   185,     0,     0,     0,   185,   153,   154,   149,
     0,     0,     0,   157,     0,   341,   100,   156,   145,   150,
     0,   155,   146,   152,     0,   151,   144,   109,   111,   153,
   154,   149,     0,    97,    98,   157,     0,     0,   100,     0,
     0,   150,     0,     0,     0,     0,     0,   151,   144,   109,
   111,     0,     0,     0,     0,    97,    98,     7,    16,     0,
     0,    22,    33,     0,     0,     0,    27,     0,    36,    19,
    26,     0,     0,     0,    24,    25,    17,     0,    23,    28,
     0,    18,    37,   332,    20,    38,    29,    21,    34,     0,
     0,     0,     0,     0,     0,     7,    16,     0,     0,    22,
    33,     0,     0,    30,    27,     0,    36,    19,    26,     0,
     0,     0,    24,    25,    17,   324,    23,    28,     0,    18,
    37,     0,    20,    38,    29,    21,    34,   107,     0,     0,
     0,     0,   102,     0,    95,     0,   103,   104,     0,   105,
     0,    30,     0,     7,    16,     0,     0,    22,    33,     0,
     0,     0,    27,   148,    36,    19,    26,     0,     0,     0,
    24,    25,    17,     0,    23,    28,     0,    18,    37,     0,
    20,    38,    29,    21,    34,     0,    16,     0,     0,    22,
    33,     0,     0,     0,    27,     0,    36,    19,    26,    30,
     0,     0,    24,    25,    17,     0,    23,    28,     0,    18,
    37,     0,    20,    38,    29,    21,    34,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    43,    22,    33,
   106,    30,     0,    27,     0,    36,     0,    26,     0,     0,
     0,    24,    25,     0,     0,    23,    28,     0,     0,    37,
     0,     0,    38,    29,    21,    34,     0,     0,     0,     0,
    22,    33,     0,     0,     0,    27,     0,    36,     0,    26,
    30,     0,     0,    24,    25,     0,     0,    23,    28,     0,
     0,    37,     0,     0,    38,    29,    21,    34,     0,     0,
    22,    33,     0,     0,     0,    27,     0,    36,     0,    26,
     0,     0,    30,    24,    25,     0,     0,    23,    28,     0,
     0,    37,     0,   107,    38,    29,    21,    34,   102,     0,
    95,     0,   103,   104,     0,   105,     0,     0,   107,     0,
     0,     0,    30,   102,     0,    95,     0,   103,   104,     0,
   105,   107,     0,     0,     0,     0,   102,     0,    95,   304,
   103,   104,     0,   105,     0,     0,     0,     0,     0,     0,
     0,     0,   156,   145,     0,     0,   155,   146,   152,     0,
     0,     0,   107,     0,   153,   154,   149,   102,     0,    95,
   157,   103,   104,   100,   105,     0,   150,     0,   377,     0,
     0,     0,   151,   144,   109,   111,     0,     0,   254,     0,
    97,    98,   107,   263,     0,   434,   106,   102,     0,    95,
     0,   103,   104,     0,   105,   107,     0,     0,     0,     0,
   102,   106,    95,   459,   103,   104,     0,   105,   107,     0,
     0,     0,     0,   102,   106,    95,   448,   103,   104,     0,
   105,   107,     0,     0,     0,     0,   102,     0,    95,   446,
   103,   104,     0,   105,   107,     0,     0,     0,     0,   102,
     0,    95,    79,   103,   104,   106,   105,   107,     0,     0,
     0,     0,   102,     0,    95,   429,   103,   104,     0,   105,
   432,     0,   107,     0,     0,     0,     0,   102,     0,    95,
     0,   103,   104,     0,   105,   106,     0,   107,     0,     0,
     0,     0,   102,     0,    95,     0,   103,   104,   106,   105,
   107,     0,     0,     0,     0,   102,     0,    95,     0,   103,
   104,   106,   105,   107,     0,     0,     0,     0,   102,     0,
    95,     0,   103,   104,   106,   105,   436,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   106,     0,   405,
     0,   379,     0,     0,     0,     0,   107,     0,     0,   100,
   106,   102,     0,    95,   305,   103,   104,     0,   105,   108,
   109,   111,   263,     0,   100,   106,    97,    98,     0,     0,
     0,     0,   357,     0,   108,   109,   111,   100,     0,     0,
   106,    97,    98,     0,     0,   256,     0,   108,   109,   111,
     0,   107,     0,   106,    97,    98,   102,     0,    95,     0,
   103,   104,     0,   105,   107,     0,   106,     0,   100,   102,
     0,    95,     0,   103,   104,    81,   105,     0,   108,   109,
   111,     0,     0,   107,     0,    97,    98,     0,   102,     0,
    95,     0,   103,   104,     0,   105,     0,     0,   100,   106,
     0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
   111,   100,     0,     0,     0,    97,    98,     0,     0,     0,
     0,   108,   109,   111,   100,     0,     0,     0,    97,    98,
     0,     0,     0,     0,   108,   109,   111,   100,     0,     0,
     0,    97,    98,     0,   106,     0,     0,   108,   109,   111,
   100,     0,     0,     0,    97,    98,     0,   106,     0,     0,
   108,   109,   111,   100,     0,     0,     0,    97,    98,     0,
   421,     0,     0,   108,   109,   111,   106,     0,   100,     0,
    97,    98,     0,   411,     0,     0,     0,     0,   108,   109,
   111,     0,     0,   100,     0,    97,    98,     0,     0,     0,
     0,     0,     0,   108,   109,   111,   100,     0,     0,     0,
    97,    98,     0,     0,     0,     0,   108,   109,   111,   100,
     0,     0,     0,    97,    98,     0,     0,     0,     0,   108,
   109,   111,     0,   107,     0,     0,    97,    98,   102,     0,
    95,     0,   103,   104,     0,   105,     0,     0,     0,   107,
     0,     0,   100,     0,   102,     0,    95,     0,   103,   104,
     0,   105,   108,   109,   111,     0,     0,     0,     0,    97,
    98,   107,     0,     0,   394,     0,   102,     0,    95,     0,
   103,   104,     0,   105,     0,     0,   107,   363,     0,     0,
     0,   102,     0,    95,     0,   103,   104,   100,   105,     0,
     0,     0,     0,     0,     0,     0,   351,   108,   109,   111,
   100,     0,     0,     0,    97,    98,     0,     0,     0,     0,
   108,   109,   111,     0,     0,   107,   106,    97,    98,   100,
   102,   322,    95,     0,   103,   104,     0,   105,     0,   108,
   109,   111,   106,     0,   107,     0,    97,    98,     0,   102,
     0,    95,     0,   103,   104,     0,   105,     0,     0,     0,
     0,     0,     0,     0,   106,     0,     0,     0,   107,     0,
     0,     0,     0,   102,     0,    95,     0,   103,   104,   106,
   105,   107,     0,     0,     0,     0,   102,     0,    95,     0,
   103,   104,     0,   105,   107,     0,     0,     0,     0,   102,
     0,    95,     0,   103,   104,     0,   105,   107,     0,     0,
     0,     0,   102,     0,    95,     0,   103,   104,   106,   105,
     0,     0,     0,   107,     0,     0,    12,     0,   102,     0,
    95,     0,   103,   104,     0,   105,     0,   106,   107,     0,
    58,     0,     0,   102,     0,    95,     0,   103,   104,     0,
   105,     0,     0,   107,     0,     0,   347,     0,   102,     0,
    95,   106,   103,   104,     0,   105,   107,     0,     0,     0,
     0,   102,   302,    95,   106,   103,   104,     0,   105,   100,
     0,     0,     0,   121,     0,     0,     0,   106,     0,   108,
   109,   111,     0,     0,     0,   100,    97,    98,     0,     0,
   106,     0,     0,     0,     0,   108,   109,   111,     0,   292,
     0,     0,    97,    98,     0,     0,   106,   100,     0,     0,
     0,     0,   186,     0,     0,     0,     0,   108,   109,   111,
     0,   106,   100,     0,    97,    98,     0,     0,     0,     0,
     0,     0,   108,   109,   111,     0,   106,     0,   290,    97,
    98,     0,   186,   186,     0,     0,   107,     0,     0,   106,
     0,   102,     0,    95,     0,   103,   104,   288,   105,     0,
     0,   100,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   108,   109,   111,     0,     0,     0,     0,    97,    98,
   100,   286,     0,     0,     0,     0,     0,     0,     0,     0,
   108,   109,   111,     0,   284,     0,     0,    97,    98,     0,
     0,   107,   186,   186,   100,     0,   102,   282,    95,     0,
   103,   104,     0,   105,   108,   109,   111,   100,   186,     0,
   280,    97,    98,     0,     0,     0,     0,   108,   109,   111,
   100,     0,     0,   186,    97,    98,   278,   186,     0,   106,
   108,   109,   111,   100,     0,     0,     0,    97,    98,     0,
     0,   276,     0,   108,   109,   111,     0,     0,     0,   100,
    97,    98,     0,     0,     0,     0,   274,     0,     0,   108,
   109,   111,     0,     0,   100,     0,    97,    98,     0,   272,
     0,     0,     0,     0,   108,   109,   111,     0,     0,   100,
     0,    97,    98,     0,   106,     0,     0,     0,     0,   108,
   109,   111,   100,     0,     0,     0,    97,    98,     0,     0,
     0,     0,   108,   109,   111,     0,     0,     0,   107,    97,
    98,     0,     0,   102,     0,    95,     0,   103,   104,     0,
   105,     0,   107,     0,     0,     0,     0,   102,     0,    95,
     0,   103,   104,     0,   105,   107,     0,     0,     0,     0,
   102,     0,   201,     0,   103,   104,     0,   105,     0,     0,
     0,   107,     0,     0,     0,     0,   102,     0,    95,   270,
   103,   104,     0,   105,   107,     0,     0,     0,     0,   102,
     0,   195,     0,   103,   104,     0,   105,     0,   107,     0,
     0,     0,   100,   102,     0,   195,     0,   103,   104,     0,
   105,     0,   108,   109,   111,     0,     0,   107,     0,    97,
    98,   106,   102,     0,    95,     0,   103,   104,     0,   105,
     0,     0,     0,     0,   268,   106,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   106,     0,
     0,     0,     0,     0,     0,     0,     0,   100,     0,     0,
     0,     0,     0,     0,   106,     0,     0,   108,   109,   111,
     0,     0,     0,     0,    97,    98,     0,   106,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   106,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   266,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   234,     0,     0,     0,     0,
     0,     0,     0,     0,   100,     0,     0,     0,   202,     0,
     0,     0,     0,     0,   108,   109,   111,     0,   100,     0,
     0,    97,    98,     0,   199,     0,     0,     0,   108,   109,
   111,   100,     0,     0,     0,    97,    98,   197,     0,     0,
     0,   108,   109,   111,     0,     0,     0,   100,    97,    98,
     0,   194,     0,     0,     0,     0,     0,   108,   109,   111,
   100,     0,     0,     0,    97,    98,     0,     0,     0,     0,
   108,   109,   111,     0,   100,     0,     0,    97,    98,     0,
     0,     0,     0,     0,   108,   109,   111,     0,     0,     0,
     0,    97,    98,   100,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   108,   109,   111,     0,     0,     0,     0,
    97,    98 };
__YYSCLASS yytabelem yypact[]={

   346,   346, -3000, -3000, -3000,    80,   118,   180,   -12,   313,
   959,   959,   959,    28, -3000,    75, -3000, -3000, -3000, -3000,
 -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000,
 -3000, -3000, -3000, -3000, -3000,   -91,   -94, -3000, -3000, -3000,
 -3000,   927,   879, -3000,   112, -3000,   373, -3000, -3000, -3000,
   313,  1399,   416, -3000, -3000, -3000,    28, -3000, -3000,    86,
   413,    76,  -136, -3000,    51,  -155, -3000, -3000,   715, -3000,
   118,   841,  1134, -3000, -3000,   927,  -168, -3000, -3000, -3000,
   -29, -3000, -3000,   -46,  -283,    37,   113,   399,  -271,  -273,
  -276,   344,   396, -3000, -3000,   258,     9,  2345,  2331,  2318,
  2302, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000,
  -264, -3000,    81, -3000,    62, -3000,   324, -3000, -3000,    -9,
 -3000, -3000, -3000, -3000, -3000,  -135,  1060,    47,  -198,  -245,
    45, -3000, -3000,   145,  1134, -3000,   623, -3000, -3000, -3000,
 -3000, -3000, -3000, -3000,   327,  2289,   304,   369, -3000,    79,
    78,    23,  -185,    17,  -205,    52,     0,  1369, -3000, -3000,
   -38,   715,  1479, -3000,    -4, -3000, -3000,  2275,  2158,  2103,
  2013,  2000,  1985,  1970,  1954,  1941,  1928,  1915,  1891,  1872,
  1833,   403,   401,   437,   314,  1060,  1060,  1796,  1338,  -206,
  -215, -3000, -3000, -3000, -3000,  2364, -3000, -3000, -3000, -3000,
 -3000,    -3, -3000, -3000, -3000, -3000, -3000, -3000,  -246,  -188,
 -3000, -3000,    25,   281,   219,  1818,  1030,    39, -3000,    36,
   998, -3000,   194,     4, -3000,    41,    96, -3000,   601, -3000,
 -3000, -3000,   799,   303,   214,   777, -3000,  1780,  2364,  1134,
  1630,  1134,  2364,  1134,  1134, -3000,  1553,  1134,   157, -3000,
 -3000, -3000, -3000, -3000, -3000,   365, -3000,  1611, -3000, -3000,
 -3000, -3000, -3000,  1479, -3000,   176,   188,  -283, -3000,    37,
 -3000,   113, -3000,   399, -3000,  -271, -3000,  -273, -3000,  -276,
 -3000,   344, -3000,   396, -3000,   396, -3000, -3000, -3000, -3000,
 -3000, -3000, -3000, -3000,  2364, -3000, -3000,   284,   310, -3000,
 -3000,    61, -3000,    12, -3000, -3000, -3000, -3000, -3000, -3000,
 -3000,   394,   389, -3000, -3000, -3000,   281,  1325,   497,   388,
 -3000,   380, -3000,   119, -3000, -3000, -3000,   359, -3000,    -6,
  2364, -3000, -3000, -3000,  -222, -3000,  1598, -3000, -3000, -3000,
 -3000, -3000,   671,  1134, -3000, -3000, -3000, -3000,   429,  -218,
   421,   379, -3000,   419, -3000,  -242,  -243,  1520,   178, -3000,
 -3000, -3000, -3000, -3000,    89, -3000,  1507,  2364,  2364, -3000,
 -3000, -3000, -3000, -3000,  2364, -3000, -3000, -3000,   116,   115,
 -3000,   378,   371, -3000, -3000, -3000, -3000,    36,  1494, -3000,
 -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000,  1134,
 -3000, -3000, -3000,   370,  -194,  1464,   173,  1451, -3000,  1310,
 -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000, -3000,
 -3000, -3000,  1134, -3000,  1134,  1134,  1134,  2364,   154, -3000,
   409,  1438,  1425,   171, -3000, -3000, -3000, -3000,  -219, -3000,
 -3000, -3000,   407, -3000,  1134, -3000, -3000,   405, -3000,   390,
  1412,  1134,   152, -3000,  1134,  1134, -3000,  1134, -3000, -3000,
   349, -3000, -3000, -3000, -3000,  1134, -3000,  1134,  1134, -3000,
 -3000, -3000, -3000,  1134, -3000 };
__YYSCLASS yytabelem yypgo[]={

     0,   586,   489,   582,   395,     4,   402,    13,   581,   363,
   576,   574,   573,   825,  2006,   572,   569,   568,   163,   566,
   128,   202,   565,   563,     1,   171,   562,     6,    10,   561,
   200,   559,     3,   365,   135,     7,   558,   556,   553,   145,
   175,     5,   552,   157,    18,     0,   551,   546,   541,   540,
   534,     8,   533,   530,   201,   529,   528,   526,   524,   522,
   520,   517,   516,   515,   513,   512,   511,   510,   509,   507,
   501,     2,     9,   498,   495,   153,   159,   131,   141,    68,
   197,   136,   147,   205,    12,   490,   483,   482,   477,   472,
   461 };
__YYSCLASS yytabelem yyr1[]={

     0,     1,     1,     2,     2,     3,     3,     8,     3,    10,
     3,     4,     4,     4,     9,     9,     7,     7,     7,     7,
     7,     7,    12,    12,    12,    12,    12,    13,    13,    13,
    13,    13,    13,    13,    13,    13,    13,    13,    13,    14,
    14,    15,    19,    15,    15,    15,    15,    15,    17,    17,
    18,    18,    11,    22,    11,    11,    21,    23,    21,    21,
    20,    25,    25,    25,    25,    26,    26,    27,    27,    27,
    27,    27,    27,    16,    31,    16,    16,    16,    16,    16,
    29,    30,    30,    30,    32,    32,    32,    32,     5,     5,
    34,    34,    34,    34,    34,    34,    34,    34,    34,    34,
    34,    34,    34,    34,    33,    33,    33,    33,    37,    37,
    35,    35,    38,    38,    39,    39,    39,    36,    36,    24,
    24,    24,    42,    42,    42,    43,    43,    40,    40,    40,
    44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
    44,    45,    45,    45,    45,    45,    45,    46,    46,    46,
    46,    46,    46,    46,    47,    47,    53,     6,     6,    55,
     6,     6,    52,    54,    54,    54,    56,    48,    58,    48,
    48,    48,    59,    48,    48,    57,    57,    60,    49,    61,
    49,    62,    49,    63,    49,    64,    49,    65,    49,    66,
    49,    67,    49,    68,    49,    69,    49,    49,    70,    49,
    49,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    51,    51,    51,    41,    41,    41,    73,    73,    71,    71,
    71,    71,    28,    74,    74,    74,    75,    75,    75,    76,
    76,    76,    77,    77,    77,    78,    78,    78,    79,    79,
    79,    80,    80,    80,    81,    81,    81,    82,    82,    82,
    82,    82,    83,    83,    83,    83,    83,    83,    83,    84,
    85,    84,    84,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    87,    87,    87,    87,    87,    87,
    86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
    86,    86,    86,    86,    88,    88,    88,    88,    90,    90,
    89,    89 };
__YYSCLASS yytabelem yyr2[]={

     0,     2,     4,     3,     2,     4,     6,     1,     8,     1,
    10,     5,     7,     5,     2,     4,     5,     2,     4,     3,
     4,     2,     2,     2,     2,     2,     3,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,    10,     1,    10,     5,     5,     9,    11,     2,     2,
     2,     4,     3,     1,     9,     3,     3,     1,     9,     7,
     7,     4,     2,     4,     2,     6,     2,     6,     4,     3,
     3,     5,     7,    10,     1,    10,     5,    11,     9,     5,
     3,     6,     2,     7,     6,     3,     5,     7,     5,     3,
     3,     7,     7,     9,     9,     7,     9,     7,     7,     7,
     9,     7,     9,     9,     2,     4,     4,     6,     2,     4,
     2,     6,     2,     6,     4,     2,     4,     7,     3,     2,
     7,     9,     2,     6,     7,     2,     4,     2,     2,     4,
     7,     5,     7,     7,     9,     5,     7,     7,     9,     9,
     9,     2,     3,     2,     2,     2,     2,     6,     8,     6,
     7,     9,     9,     7,     5,     3,     1,    11,     7,     1,
     9,     5,     3,     5,     2,     5,     1,    13,     1,    13,
     7,    11,     1,    13,     7,     2,     6,     1,    13,     1,
    17,     1,    15,     1,    17,     1,    17,     1,    17,     1,
    19,     1,    19,     1,    19,     1,    21,     7,     1,    13,
     7,     7,     5,     5,     5,     7,     5,     5,     5,     5,
     6,     2,     7,     2,     6,     7,     2,     3,     2,    10,
    11,    11,     2,     2,     6,     7,     2,     6,     7,     2,
     6,     7,     2,     6,     7,     2,     6,     7,     2,     6,
     7,     2,     6,     7,     2,     6,     7,     2,     6,     6,
     7,     7,     2,     6,     6,     6,     7,     7,     7,     2,
     1,    10,     9,     2,     4,     4,     4,     4,     9,     5,
     5,     5,     5,     9,     2,     2,     2,     2,     2,     2,
     2,     9,     9,     7,     7,     7,     5,     5,     7,     9,
     7,     9,     7,     7,     3,     2,     2,     7,     2,     4,
     2,     6 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -1,    -2,    -3,    -4,    -5,    -7,   256,   -33,   -34,
   -12,   -13,   -14,    42,   289,    40,   257,   275,   280,   268,
   283,   286,   260,   277,   273,   274,   269,   265,   278,   285,
   302,   -15,   -16,   261,   287,   -17,   267,   281,   284,    -2,
    -6,    -8,   -52,   123,    -5,    59,   -11,   -21,   256,    59,
   -34,    91,    40,    -7,    -7,    -7,   -37,   -33,   -14,    -5,
   256,   289,   123,   256,   -29,   123,   256,   289,    -9,    -4,
    -7,    -9,   -55,   125,    -6,   -10,    61,    59,    44,    93,
   -28,   256,   -71,   -74,   -75,   -76,   -77,   -78,   -79,   -80,
   -81,   -82,   -83,   -84,   -72,    40,   -86,   296,   297,   -87,
   279,   -88,    38,    42,    43,    45,   126,    33,   289,   290,
   -90,   291,   -35,    41,   -36,   256,   -38,   289,   -39,    -7,
   -33,   -14,    41,   256,    41,   123,   -19,   256,   123,   -31,
   256,    -6,    -4,    -5,   -53,   125,   -54,   -45,   -46,   -47,
    -6,   -48,   -49,   -50,   289,   259,   263,   -51,    59,   272,
   282,   288,   264,   270,   271,   262,   258,   276,   -41,   -71,
   -72,    -9,   -23,   256,   -22,    93,   256,    63,   298,   299,
   124,    94,    38,   293,   294,   295,    43,    45,    42,    47,
    37,   -43,   256,   -51,   -25,   -13,   -14,    91,    40,    46,
   300,   296,   297,   -72,   256,    40,   -72,   256,   -84,   256,
   -72,    40,   256,   291,    41,   256,    41,   256,    44,    44,
    -5,   -40,   -33,   -44,    40,    91,   -18,   256,   -20,   -25,
   -18,   125,   -30,   256,   -32,   289,   -30,   125,   -54,   125,
   -45,   256,    58,   -28,   256,    58,    59,    44,    40,   256,
    40,   256,    40,   256,   -61,   256,    40,   256,   289,   256,
    59,   256,    59,   256,    59,   -51,   256,   -73,   292,    61,
    -6,   -24,   -41,   123,   -21,   -51,   256,   -75,   256,   -76,
   256,   -77,   256,   -78,   256,   -79,   256,   -80,   256,   -81,
   256,   -82,   256,   -83,   256,   -83,   256,   -84,   256,   -84,
   256,   -84,   256,    41,    41,    41,   -40,   -33,    40,   -25,
   -25,   -51,   256,   -89,    41,   256,   -41,   289,   256,   289,
   256,   -43,   256,   289,   301,   -39,   -44,    91,    40,   -40,
    41,   -35,    93,   -28,   125,   -20,   125,   -26,   -27,    -5,
    58,   256,   125,   125,    44,   125,    61,   256,   125,   125,
   -45,   256,    58,    58,   -45,   256,   -41,   256,   -51,   -45,
   -51,   256,   -45,   -51,   -45,   -45,   -70,    59,   -51,   -45,
    59,    59,   -41,   256,   -42,   -24,    58,    58,   -85,   -84,
    93,   256,    41,   256,    44,    41,    41,    93,   -28,   256,
    41,   -35,   256,    41,    41,    93,    59,    44,    58,   256,
   -28,   -32,   256,   -28,   256,   -45,   256,   -45,    41,   266,
    41,    41,    41,   288,   288,    59,   -51,    59,   125,    44,
   -71,   256,   -71,   -84,   -41,    93,    93,    41,    41,   -27,
   -28,   256,   -56,   -45,   -58,   -59,   -60,    40,   256,    41,
   -51,    59,    59,   -51,   125,   -24,   256,   -57,   -45,   -45,
   -45,   -45,   -51,    59,   -62,    41,    41,   -51,    41,   -51,
    59,   266,    41,   -45,   -65,   -64,    41,   -63,    41,    41,
   -51,   -45,    59,   -45,   -45,   -67,   -45,   -68,   -66,    41,
   -45,   -45,   -45,   -69,   -45 };
__YYSCLASS yytabelem yydef[]={

     0,    -2,     1,     3,     4,     7,     0,     0,     0,    89,
    17,    19,    21,   104,    90,     0,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,     0,     0,    48,    49,     2,
     5,     0,    -2,   162,    -2,    11,     0,    52,    55,    13,
    88,     0,     0,    16,    18,    20,   105,   106,   108,     0,
     0,    44,    -2,    45,    76,    -2,    79,    80,     0,    14,
     0,    -2,     0,   161,     6,     0,    -2,    12,    53,    92,
     0,    99,   222,   218,   223,   226,   229,   232,   235,   238,
   241,   244,   247,   252,   259,     0,   263,     0,     0,     0,
     0,   280,   274,   275,   276,   277,   278,   279,   294,   295,
   296,   298,     0,    95,     0,   101,   110,   118,   112,   115,
   107,   109,    91,    98,    97,     0,     0,     0,     0,     0,
     0,     8,    15,    56,     0,   158,     0,   164,   141,   142,
   143,   144,   145,   146,   294,     0,     0,     0,   155,     0,
     0,     0,    -2,     0,     0,     0,     0,     0,   211,   213,
   259,     0,     0,    59,     0,    93,   100,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   125,    62,    64,     0,     0,     0,
     0,   286,   287,   264,   269,     0,   265,   270,   266,   271,
   267,     0,   272,   299,    94,   102,    96,   103,     0,     0,
   114,   116,   127,   128,     0,     0,     0,     0,    50,     0,
     0,    46,     0,     0,    82,    -2,     0,    78,     0,   160,
   163,   165,     0,     0,     0,     0,   154,     0,     0,     0,
     0,     0,     0,     0,     0,   198,     0,     0,     0,   206,
   202,   207,   203,   208,   204,     0,   209,     0,   216,   217,
    10,    58,   119,     0,    54,     0,     0,   224,   225,   227,
   228,   230,   231,   233,   234,   236,   237,   239,   240,   242,
   243,   245,   246,   248,   250,   249,   251,   253,   256,   254,
   257,   255,   258,   260,     0,   297,   126,   127,     0,    61,
    63,     0,   288,     0,   283,   290,   300,   284,   292,   285,
   293,     0,     0,   117,   111,   113,   129,     0,     0,     0,
   135,     0,   131,     0,    41,    51,    47,     0,    66,    -2,
     0,    70,    43,    73,     0,    77,     0,    86,    75,   157,
   147,   150,     0,     0,   149,   153,   210,   212,     0,   170,
     0,     0,   174,     0,   197,     0,     0,     0,     0,   200,
   201,   205,   214,   215,     0,   122,     0,     0,     0,   262,
   281,   289,   282,   291,     0,   268,   273,   132,     0,     0,
   136,     0,     0,   130,   137,   133,    60,     0,     0,    71,
    68,    81,    83,    84,    87,   148,   152,   151,   166,     0,
   168,   172,   177,     0,     0,     0,     0,     0,   120,     0,
   219,   221,   220,   261,   301,   134,   139,   138,   140,    65,
    67,    72,     0,   171,     0,     0,     0,     0,     0,   181,
     0,     0,     0,     0,   121,   123,   124,   167,   175,   169,
   173,   178,     0,   199,     0,   187,   185,     0,   183,     0,
     0,     0,     0,   182,     0,     0,   191,     0,   193,   189,
     0,   176,   180,   188,   186,     0,   184,     0,     0,   195,
   192,   194,   190,     0,   196 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"AUTO",	257,
	"BREAK",	258,
	"CASE",	259,
	"CHAR",	260,
	"CONST",	261,
	"CONTINUE",	262,
	"DEFAULT",	263,
	"DO",	264,
	"DOUBLE",	265,
	"ELSE",	266,
	"ENUM",	267,
	"EXTERN",	268,
	"FLOAT",	269,
	"FOR",	270,
	"GOTO",	271,
	"IF",	272,
	"INT",	273,
	"LONG",	274,
	"REGISTER",	275,
	"RETURN",	276,
	"SHORT",	277,
	"SIGNED",	278,
	"SIZEOF",	279,
	"STATIC",	280,
	"STRUCT",	281,
	"SWITCH",	282,
	"TYPEDEF",	283,
	"UNION",	284,
	"UNSIGNED",	285,
	"VOID",	286,
	"VOLATILE",	287,
	"WHILE",	288,
	"IDENTIFIER",	289,
	"CONSTANT",	290,
	"STRING",	291,
	"ASSIGN_OP",	292,
	"EQUALITY_OP",	293,
	"RELATIONAL_OP",	294,
	"SHIFT_OP",	295,
	"INCREMENT",	296,
	"DECREMENT",	297,
	"OR",	298,
	"AND",	299,
	"INDIRECT_SELECTION",	300,
	"ELIPSIS",	301,
	"TYPEDEF_NAME",	302,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"translation_unit : external_definition",
	"translation_unit : translation_unit external_definition",
	"external_definition : function_definition",
	"external_definition : declaration",
	"function_definition : declarator compound_statement",
	"function_definition : declaration_specifiers declarator compound_statement",
	"function_definition : declarator",
	"function_definition : declarator declaration_list compound_statement",
	"function_definition : declaration_specifiers declarator",
	"function_definition : declaration_specifiers declarator declaration_list compound_statement",
	"declaration : declaration_specifiers ';'",
	"declaration : declaration_specifiers init_declarator_list ';'",
	"declaration : error ';'",
	"declaration_list : declaration",
	"declaration_list : declaration_list declaration",
	"declaration_specifiers : storage_class_specifier declaration_specifiers",
	"declaration_specifiers : storage_class_specifier",
	"declaration_specifiers : type_specifier declaration_specifiers",
	"declaration_specifiers : type_specifier",
	"declaration_specifiers : type_qualifier declaration_specifiers",
	"declaration_specifiers : type_qualifier",
	"storage_class_specifier : AUTO",
	"storage_class_specifier : REGISTER",
	"storage_class_specifier : STATIC",
	"storage_class_specifier : EXTERN",
	"storage_class_specifier : TYPEDEF",
	"type_specifier : VOID",
	"type_specifier : CHAR",
	"type_specifier : SHORT",
	"type_specifier : INT",
	"type_specifier : LONG",
	"type_specifier : FLOAT",
	"type_specifier : DOUBLE",
	"type_specifier : SIGNED",
	"type_specifier : UNSIGNED",
	"type_specifier : TYPEDEF_NAME",
	"type_specifier : struct_or_union_specifier",
	"type_specifier : enum_specifier",
	"type_qualifier : CONST",
	"type_qualifier : VOLATILE",
	"struct_or_union_specifier : struct_or_union IDENTIFIER '{' struct_declaration_list '}'",
	"struct_or_union_specifier : struct_or_union '{'",
	"struct_or_union_specifier : struct_or_union '{' struct_declaration_list '}'",
	"struct_or_union_specifier : struct_or_union IDENTIFIER",
	"struct_or_union_specifier : struct_or_union error",
	"struct_or_union_specifier : struct_or_union '{' error '}'",
	"struct_or_union_specifier : struct_or_union IDENTIFIER '{' error '}'",
	"struct_or_union : STRUCT",
	"struct_or_union : UNION",
	"struct_declaration_list : struct_declaration",
	"struct_declaration_list : struct_declaration_list struct_declaration",
	"init_declarator_list : init_declarator",
	"init_declarator_list : init_declarator_list ','",
	"init_declarator_list : init_declarator_list ',' init_declarator",
	"init_declarator_list : error",
	"init_declarator : declarator",
	"init_declarator : declarator '='",
	"init_declarator : declarator '=' initializer",
	"init_declarator : declarator '=' error",
	"struct_declaration : specifier_qaulifier_list struct_declarator_list ';'",
	"specifier_qaulifier_list : type_specifier specifier_qaulifier_list",
	"specifier_qaulifier_list : type_specifier",
	"specifier_qaulifier_list : type_qualifier specifier_qaulifier_list",
	"specifier_qaulifier_list : type_qualifier",
	"struct_declarator_list : struct_declarator_list ',' struct_declarator",
	"struct_declarator_list : struct_declarator",
	"struct_declarator : declarator ':' constant_expression",
	"struct_declarator : ':' constant_expression",
	"struct_declarator : declarator",
	"struct_declarator : error",
	"struct_declarator : declarator error",
	"struct_declarator : declarator ':' error",
	"enum_specifier : ENUM enum_identifier '{' enumerator_list '}'",
	"enum_specifier : ENUM '{'",
	"enum_specifier : ENUM '{' enumerator_list '}'",
	"enum_specifier : ENUM enum_identifier",
	"enum_specifier : ENUM enum_identifier '{' error '}'",
	"enum_specifier : ENUM '{' error '}'",
	"enum_specifier : ENUM error",
	"enum_identifier : IDENTIFIER",
	"enumerator_list : enumerator_list ',' enumerator",
	"enumerator_list : enumerator",
	"enumerator_list : enumerator_list ',' error",
	"enumerator : IDENTIFIER '=' constant_expression",
	"enumerator : IDENTIFIER",
	"enumerator : IDENTIFIER error",
	"enumerator : IDENTIFIER '=' error",
	"declarator : pointer direct_declarator",
	"declarator : direct_declarator",
	"direct_declarator : IDENTIFIER",
	"direct_declarator : '(' declarator ')'",
	"direct_declarator : direct_declarator '[' ']'",
	"direct_declarator : direct_declarator '[' constant_expression ']'",
	"direct_declarator : direct_declarator '(' parameter_type_list ')'",
	"direct_declarator : direct_declarator '(' ')'",
	"direct_declarator : direct_declarator '(' identifier_list ')'",
	"direct_declarator : '(' error ')'",
	"direct_declarator : '(' declarator error",
	"direct_declarator : direct_declarator '[' error",
	"direct_declarator : direct_declarator '[' constant_expression error",
	"direct_declarator : direct_declarator '(' error",
	"direct_declarator : direct_declarator '(' parameter_type_list error",
	"direct_declarator : direct_declarator '(' identifier_list error",
	"pointer : '*'",
	"pointer : '*' type_qualifier_list",
	"pointer : '*' pointer",
	"pointer : '*' type_qualifier_list pointer",
	"type_qualifier_list : type_qualifier",
	"type_qualifier_list : type_qualifier_list type_qualifier",
	"parameter_type_list : parameter_list",
	"parameter_type_list : parameter_list ',' ELIPSIS",
	"parameter_list : parameter_declaration",
	"parameter_list : parameter_list ',' parameter_declaration",
	"parameter_declaration : declaration_specifiers declarator",
	"parameter_declaration : declaration_specifiers",
	"parameter_declaration : declaration_specifiers abstract_declarator",
	"identifier_list : identifier_list ',' IDENTIFIER",
	"identifier_list : IDENTIFIER",
	"initializer : assignment_expression",
	"initializer : '{' initializer_list '}'",
	"initializer : '{' initializer_list ',' '}'",
	"initializer_list : initializer",
	"initializer_list : initializer_list ',' initializer",
	"initializer_list : initializer_list ',' error",
	"type_name : specifier_qaulifier_list",
	"type_name : specifier_qaulifier_list abstract_declarator",
	"abstract_declarator : pointer",
	"abstract_declarator : direct_abstract_declarator",
	"abstract_declarator : pointer direct_abstract_declarator",
	"direct_abstract_declarator : '(' abstract_declarator ')'",
	"direct_abstract_declarator : '[' ']'",
	"direct_abstract_declarator : direct_abstract_declarator '[' ']'",
	"direct_abstract_declarator : '[' constant_expression ']'",
	"direct_abstract_declarator : direct_abstract_declarator '[' constant_expression ']'",
	"direct_abstract_declarator : '(' ')'",
	"direct_abstract_declarator : direct_abstract_declarator '(' ')'",
	"direct_abstract_declarator : '(' parameter_type_list ')'",
	"direct_abstract_declarator : direct_abstract_declarator '(' parameter_type_list ')'",
	"direct_abstract_declarator : direct_abstract_declarator '[' error ']'",
	"direct_abstract_declarator : direct_abstract_declarator '(' error ')'",
	"statement : labeled_statement",
	"statement : expression_statement",
	"statement : compound_statement",
	"statement : selection_statement",
	"statement : iteration_statement",
	"statement : jump_statement",
	"labeled_statement : IDENTIFIER ':' statement",
	"labeled_statement : CASE constant_expression ':' statement",
	"labeled_statement : DEFAULT ':' statement",
	"labeled_statement : IDENTIFIER ':' error",
	"labeled_statement : CASE error ':' statement",
	"labeled_statement : CASE constant_expression ':' error",
	"labeled_statement : DEFAULT ':' error",
	"expression_statement : expression ';'",
	"expression_statement : ';'",
	"compound_statement : start_code declaration_list",
	"compound_statement : start_code declaration_list statement_list '}'",
	"compound_statement : start_code declaration_list '}'",
	"compound_statement : start_code",
	"compound_statement : start_code statement_list '}'",
	"compound_statement : start_code '}'",
	"start_code : '{'",
	"statement_list : statement_list statement",
	"statement_list : statement",
	"statement_list : statement_list error",
	"selection_statement : IF '(' expression ')'",
	"selection_statement : IF '(' expression ')' if_statement",
	"selection_statement : SWITCH '(' expression ')'",
	"selection_statement : SWITCH '(' expression ')' statement",
	"selection_statement : IF error statement",
	"selection_statement : IF error statement ELSE statement",
	"selection_statement : SWITCH '(' error ')'",
	"selection_statement : SWITCH '(' error ')' statement",
	"selection_statement : SWITCH error statement",
	"if_statement : statement",
	"if_statement : statement ELSE statement",
	"iteration_statement : WHILE '(' expression ')'",
	"iteration_statement : WHILE '(' expression ')' statement",
	"iteration_statement : DO",
	"iteration_statement : DO statement WHILE '(' expression ')' ';'",
	"iteration_statement : FOR '(' ';' ';' ')'",
	"iteration_statement : FOR '(' ';' ';' ')' statement",
	"iteration_statement : FOR '(' expression ';' ';' ')'",
	"iteration_statement : FOR '(' expression ';' ';' ')' statement",
	"iteration_statement : FOR '(' ';' expression ';' ')'",
	"iteration_statement : FOR '(' ';' expression ';' ')' statement",
	"iteration_statement : FOR '(' ';' ';' expression ')'",
	"iteration_statement : FOR '(' ';' ';' expression ')' statement",
	"iteration_statement : FOR '(' expression ';' expression ';' ')'",
	"iteration_statement : FOR '(' expression ';' expression ';' ')' statement",
	"iteration_statement : FOR '(' ';' expression ';' expression ')'",
	"iteration_statement : FOR '(' ';' expression ';' expression ')' statement",
	"iteration_statement : FOR '(' expression ';' ';' expression ')'",
	"iteration_statement : FOR '(' expression ';' ';' expression ')' statement",
	"iteration_statement : FOR '(' expression ';' expression ';' expression ')'",
	"iteration_statement : FOR '(' expression ';' expression ';' expression ')' statement",
	"iteration_statement : WHILE error statement",
	"iteration_statement : DO error",
	"iteration_statement : DO error WHILE error ';'",
	"iteration_statement : FOR error statement",
	"jump_statement : GOTO IDENTIFIER ';'",
	"jump_statement : CONTINUE ';'",
	"jump_statement : BREAK ';'",
	"jump_statement : RETURN ';'",
	"jump_statement : RETURN expression ';'",
	"jump_statement : GOTO error",
	"jump_statement : CONTINUE error",
	"jump_statement : BREAK error",
	"jump_statement : RETURN error",
	"expression : expression ',' assignment_expression",
	"expression : assignment_expression",
	"expression : expression ',' error",
	"assignment_expression : conditional_expression",
	"assignment_expression : unary_expression assignment_operator assignment_expression",
	"assignment_expression : unary_expression assignment_operator error",
	"assignment_operator : ASSIGN_OP",
	"assignment_operator : '='",
	"conditional_expression : logical_or_expression",
	"conditional_expression : logical_or_expression '?' expression ':' conditional_expression",
	"conditional_expression : logical_or_expression '?' error ':' conditional_expression",
	"conditional_expression : logical_or_expression '?' expression ':' error",
	"constant_expression : conditional_expression",
	"logical_or_expression : logical_and_expression",
	"logical_or_expression : logical_or_expression OR logical_and_expression",
	"logical_or_expression : logical_or_expression OR error",
	"logical_and_expression : inclusive_or_expression",
	"logical_and_expression : logical_and_expression AND inclusive_or_expression",
	"logical_and_expression : logical_and_expression AND error",
	"inclusive_or_expression : exclusive_or_expression",
	"inclusive_or_expression : inclusive_or_expression '|' exclusive_or_expression",
	"inclusive_or_expression : inclusive_or_expression '|' error",
	"exclusive_or_expression : and_expression",
	"exclusive_or_expression : exclusive_or_expression '^' and_expression",
	"exclusive_or_expression : exclusive_or_expression '^' error",
	"and_expression : equality_expression",
	"and_expression : and_expression '&' equality_expression",
	"and_expression : and_expression '&' error",
	"equality_expression : relational_expression",
	"equality_expression : equality_expression EQUALITY_OP relational_expression",
	"equality_expression : equality_expression EQUALITY_OP error",
	"relational_expression : shift_expression",
	"relational_expression : relational_expression RELATIONAL_OP shift_expression",
	"relational_expression : relational_expression RELATIONAL_OP error",
	"shift_expression : additive_expression",
	"shift_expression : shift_expression SHIFT_OP additive_expression",
	"shift_expression : shift_expression SHIFT_OP error",
	"additive_expression : multiplicative_expression",
	"additive_expression : additive_expression '+' multiplicative_expression",
	"additive_expression : additive_expression '-' multiplicative_expression",
	"additive_expression : additive_expression '+' error",
	"additive_expression : additive_expression '-' error",
	"multiplicative_expression : cast_expression",
	"multiplicative_expression : multiplicative_expression '*' cast_expression",
	"multiplicative_expression : multiplicative_expression '/' cast_expression",
	"multiplicative_expression : multiplicative_expression '%' cast_expression",
	"multiplicative_expression : multiplicative_expression '*' error",
	"multiplicative_expression : multiplicative_expression '/' error",
	"multiplicative_expression : multiplicative_expression '%' error",
	"cast_expression : unary_expression",
	"cast_expression : '(' type_name ')'",
	"cast_expression : '(' type_name ')' cast_expression",
	"cast_expression : '(' error ')' cast_expression",
	"unary_expression : postfix_expression",
	"unary_expression : INCREMENT unary_expression",
	"unary_expression : DECREMENT unary_expression",
	"unary_expression : unary_operator cast_expression",
	"unary_expression : SIZEOF unary_expression",
	"unary_expression : SIZEOF '(' type_name ')'",
	"unary_expression : INCREMENT error",
	"unary_expression : DECREMENT error",
	"unary_expression : unary_operator error",
	"unary_expression : SIZEOF error",
	"unary_expression : SIZEOF '(' error ')'",
	"unary_operator : '&'",
	"unary_operator : '*'",
	"unary_operator : '+'",
	"unary_operator : '-'",
	"unary_operator : '~'",
	"unary_operator : '!'",
	"postfix_expression : primary_expression",
	"postfix_expression : postfix_expression '[' expression ']'",
	"postfix_expression : postfix_expression '(' argument_expression_list ')'",
	"postfix_expression : postfix_expression '(' ')'",
	"postfix_expression : postfix_expression '.' IDENTIFIER",
	"postfix_expression : postfix_expression INDIRECT_SELECTION IDENTIFIER",
	"postfix_expression : postfix_expression INCREMENT",
	"postfix_expression : postfix_expression DECREMENT",
	"postfix_expression : postfix_expression '[' error",
	"postfix_expression : postfix_expression '[' expression error",
	"postfix_expression : postfix_expression '(' error",
	"postfix_expression : postfix_expression '(' argument_expression_list error",
	"postfix_expression : postfix_expression '.' error",
	"postfix_expression : postfix_expression INDIRECT_SELECTION error",
	"primary_expression : IDENTIFIER",
	"primary_expression : CONSTANT",
	"primary_expression : string_conat",
	"primary_expression : '(' expression ')'",
	"string_conat : STRING",
	"string_conat : string_conat STRING",
	"argument_expression_list : assignment_expression",
	"argument_expression_list : argument_expression_list ',' assignment_expression",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 70.7 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/

#ifdef YYREENTRANT
__thread int yydebug;		/* set to 1 to get debugging */
#else
int yydebug;			/* set to 1 to get debugging */
#endif

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH

#   ifdef YYREENTRANT
__thread __YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];  /* value stack */
__thread __YYSCLASS int yys[ YYMAXDEPTH ];      /* state stack */
#   else
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];           /* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];               /* state stack */
#   endif

# else

#  ifdef YYREENTRANT
__thread __YYSCLASS YYSTYPE *yyv;               /* pointer to malloc'ed stack st
value stack */
__thread __YYSCLASS int *yys;                   /* pointer to malloc'ed stack st
ack */
#  else
__YYSCLASS YYSTYPE *yyv;                        /* pointer to malloc'ed value st
ack */
__YYSCLASS int *yys;                            /* pointer to malloc'ed stack stack */
#  endif

#if defined(__STDC__) || defined (__cplusplus)
#include <stdlib.h>
#else
	extern char *malloc();
	extern char *realloc();
	extern void free();
#endif /* __STDC__ or __cplusplus */


static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;


#ifdef YYREENTRANT

__thread __YYSCLASS YYSTYPE *yypv;      /* top of value stack */
__thread __YYSCLASS int *yyps;          /* top of state stack */

__thread __YYSCLASS int yystate;        /* current state */
__thread __YYSCLASS int yytmp;          /* extra var (lasts between blocks) */

__thread int yynerrs;                   /* number of errors */
__thread __YYSCLASS int yyerrflag;      /* error recovery flag */
__thread int yychar;                    /* current input token number */

__thread extern int yyinit_key;           /* init TLS data once */
extern int TLS_INIT; 

#else

__YYSCLASS YYSTYPE *yypv;               /* top of value stack */
__YYSCLASS int *yyps;                   /* top of state stack */

__YYSCLASS int yystate;                 /* current state */
__YYSCLASS int yytmp;                   /* extra var (lasts between blocks) */

int yynerrs;                            /* number of errors */
__YYSCLASS int yyerrflag;               /* error recovery flag */
int yychar;
#endif


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
l*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */


        /*
        ** Initialize externals - yyparse may be called more than once
        */

#ifdef YYREENTRANT
        if (yyinit_key != TLS_INIT)
        {
            yyinit_key = TLS_INIT; 
            yyinit_tls();
        }
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 37 "ansic.y"
{ in_stmt = 0; } break;
case 7:
# line 44 "ansic.y"
{ start_parm_def(); } break;
case 9:
# line 45 "ansic.y"
{ start_parm_def(); } break;
case 11:
# line 51 "ansic.y"
{
            if(flag_23 == 1) {
              flag_23 = flag_16 = flag_13 = 0;
              flag_47 = flag_66 = 0;
              }
            yyerrok; } break;
case 12:
# line 58 "ansic.y"
{
	    if(where_in_code==WHERE_PROTO) prototype();
            if(flag_23 == 1) {
              flag_23 = flag_16 = flag_13 = 0;
              flag_47 = flag_66 = 0;
              }
            yyerrok; } break;
case 13:
# line 66 "ansic.y"
{ ERROR("declaration: error ;"); } break;
case 16:
# line 76 "ansic.y"
{ if(flag_16 == 1) flag_13 = 1; } break;
case 19:
# line 80 "ansic.y"
{ if(flag_23 == 1) flag_16 = 1; } break;
case 26:
# line 91 "ansic.y"
{ if(flag_23 == 0) flag_23 = 1; } break;
case 42:
# line 116 "ansic.y"
{ find_struct = 0; } break;
case 44:
# line 118 "ansic.y"
{ yyerrok; } break;
case 45:
# line 120 "ansic.y"
{ ERROR("struct_or_union_specifier: struct_or_union error"); } break;
case 46:
# line 122 "ansic.y"
{ ERROR("struct_or_union_specifier: struct_or_union { error }"); } break;
case 47:
# line 124 "ansic.y"
{ ERROR("struct_or_union_specifier: struct_or_union IDENTIFIER { error }"); } break;
case 52:
# line 139 "ansic.y"
{ if(flag_47 == 1) {
                flag_16 = flag_13 = 1;
                flag_66 = flag_47 = 0;
                }
              } break;
case 53:
# line 145 "ansic.y"
{ if(where_in_code==WHERE_PROTO) prototype(); } break;
case 54:
# line 147 "ansic.y"
{ if(flag_47 == 1) {
                flag_16 = flag_13 = 1;
                flag_66 = flag_47 = 0;
                }
              } break;
case 55:
# line 153 "ansic.y"
{ ERROR("init_declarator_list: error"); } break;
case 56:
# line 158 "ansic.y"
{ if(flag_66 == 1) flag_47 = 1; } break;
case 57:
# line 159 "ansic.y"
{ initialize_id(); } break;
case 58:
# line 160 "ansic.y"
{ if(flag_66 == 1) flag_47 = 1; yyerrok; } break;
case 59:
# line 162 "ansic.y"
{ ERROR("init_declarator: declarator = error"); } break;
case 60:
# line 167 "ansic.y"
{ yyerrok; } break;
case 69:
# line 186 "ansic.y"
{ yyerrok; } break;
case 70:
# line 188 "ansic.y"
{ ERROR("struct_declarator: error"); } break;
case 71:
# line 190 "ansic.y"
{ ERROR("struct_declarator: declarator error"); } break;
case 72:
# line 192 "ansic.y"
{ ERROR("struct_declarator: declarator : error"); } break;
case 74:
# line 197 "ansic.y"
{ find_struct = 0; } break;
case 76:
# line 199 "ansic.y"
{ yyerrok; } break;
case 77:
# line 201 "ansic.y"
{ ERROR("enum_specifier: ENUM IDENTIFIER { error }"); } break;
case 78:
# line 203 "ansic.y"
{ ERROR("enum_specifier: ENUM { error }"); } break;
case 79:
# line 205 "ansic.y"
{ ERROR("enum_specifier: ENUM error"); } break;
case 80:
# line 209 "ansic.y"
{ add_to_list(); initialize_id(); } break;
case 83:
# line 216 "ansic.y"
{ ERROR("enumerator_list: enumerator_list , error"); } break;
case 85:
# line 222 "ansic.y"
{ /* PWO */ add_to_list(); yyerrok; } break;
case 86:
# line 224 "ansic.y"
{ ERROR("enumerator: IDENTIFIER error"); } break;
case 87:
# line 226 "ansic.y"
{ ERROR("enumerator: IDENTIFIER = error"); } break;
case 88:
# line 231 "ansic.y"
{ if(flag_23 == 1) flag_66 = 1; } break;
case 89:
# line 233 "ansic.y"
{ if(flag_23 == 1) flag_66 = 1; } break;
case 90:
# line 238 "ansic.y"
{ if(flag_13 == 1) {
                type_in(yytext);
                flag_16 = flag_13 = 0;
                }
              add_to_list(); } break;
case 91:
# line 244 "ansic.y"
{ yyerrok; } break;
case 92:
# line 246 "ansic.y"
{ yyerrok; } break;
case 93:
# line 248 "ansic.y"
{ yyerrok; } break;
case 94:
# line 250 "ansic.y"
{ yyerrok; } break;
case 95:
# line 252 "ansic.y"
{ yyerrok; } break;
case 96:
# line 254 "ansic.y"
{ yyerrok; } break;
case 97:
# line 256 "ansic.y"
{ yyerrok; ERROR("direct_declarator: (error)"); } break;
case 98:
# line 258 "ansic.y"
{ ERROR("direct_declarator: (declarator error"); } break;
case 99:
# line 260 "ansic.y"
{ ERROR("direct_declarator: direct_declarator [error"); } break;
case 100:
# line 262 "ansic.y"
{ ERROR("direct_declarator: direct_declarator [constant_expression error"); } break;
case 101:
# line 264 "ansic.y"
{ ERROR("direct_declarator: direct_declarator (error"); } break;
case 102:
# line 266 "ansic.y"
{ ERROR("direct_declarator: direct_declarator (parameter_type_list error"); } break;
case 103:
# line 268 "ansic.y"
{ ERROR("direct_declarator: direct_declarator (identifier_list error"); } break;
case 117:
# line 300 "ansic.y"
{ /* PWO */ add_to_list(); } break;
case 118:
# line 301 "ansic.y"
{ /* PWO */ add_to_list(); } break;
case 120:
# line 307 "ansic.y"
{ yyerrok; } break;
case 121:
# line 309 "ansic.y"
{ yyerrok; } break;
case 124:
# line 316 "ansic.y"
{ ERROR("initializer_list: initializer_list , error"); } break;
case 130:
# line 332 "ansic.y"
{ yyerrok; } break;
case 131:
# line 334 "ansic.y"
{ yyerrok; } break;
case 132:
# line 336 "ansic.y"
{ yyerrok; } break;
case 133:
# line 338 "ansic.y"
{ yyerrok; } break;
case 134:
# line 340 "ansic.y"
{ yyerrok; } break;
case 135:
# line 342 "ansic.y"
{ yyerrok; } break;
case 136:
# line 344 "ansic.y"
{ yyerrok; } break;
case 137:
# line 346 "ansic.y"
{ yyerrok; } break;
case 138:
# line 348 "ansic.y"
{ yyerrok; } break;
case 139:
# line 350 "ansic.y"
{ ERROR("direct_abstract_declarator: direct_abstract_declarator [ error ]"); } break;
case 140:
# line 352 "ansic.y"
{ ERROR("direct_abstract_declarator: direct_abstract_declarator ( error )"); } break;
case 142:
# line 358 "ansic.y"
{ in_stmt = 1; } break;
case 150:
# line 370 "ansic.y"
{ ERROR("labeled_statement: IDENTIFIER : error"); } break;
case 151:
# line 372 "ansic.y"
{ ERROR("labeled_statement: CASE error : statement"); } break;
case 152:
# line 374 "ansic.y"
{ ERROR("labeled_statement: CASE constant_expression : error"); } break;
case 153:
# line 376 "ansic.y"
{ ERROR("labeled_statement: DEFAULT : error"); } break;
case 154:
# line 381 "ansic.y"
{ in_stmt = 0; yyerrok; } break;
case 155:
# line 383 "ansic.y"
{ in_stmt = 0; yyerrok; } break;
case 156:
# line 387 "ansic.y"
{ in_stmt = 1; start_statement(); } break;
case 157:
# line 388 "ansic.y"
{ end_code_block(); yyerrok; } break;
case 158:
# line 389 "ansic.y"
{end_code_block(); yyerrok; } break;
case 159:
# line 390 "ansic.y"
{ start_statement(); in_stmt = 1; } break;
case 160:
# line 391 "ansic.y"
{ end_code_block(); yyerrok; } break;
case 161:
# line 392 "ansic.y"
{ end_code_block(); yyerrok; } break;
case 162:
# line 396 "ansic.y"
{start_code_block();} break;
case 163:
# line 401 "ansic.y"
{ yyerrok; } break;
case 165:
# line 404 "ansic.y"
{ ERROR("statement_list: statement_list error"); } break;
case 166:
# line 408 "ansic.y"
{nesting('{');} break;
case 167:
# line 408 "ansic.y"
{nesting('}');} break;
case 168:
# line 410 "ansic.y"
{ yyerrok; nesting('{'); } break;
case 169:
# line 411 "ansic.y"
{nesting('}');} break;
case 170:
# line 413 "ansic.y"
{ ERROR("selection_statement: IF error statement"); } break;
case 171:
# line 415 "ansic.y"
{ ERROR("selection_statement: IF error statement ELSE statement"); } break;
case 172:
# line 417 "ansic.y"
{ yyerrok; } break;
case 173:
# line 419 "ansic.y"
{ ERROR("selection_statement: SWITCH (error) statement"); } break;
case 174:
# line 421 "ansic.y"
{ ERROR("selection_statement: SWITCH error statement"); } break;
case 177:
# line 431 "ansic.y"
{nesting('{');} break;
case 178:
# line 431 "ansic.y"
{nesting('}');} break;
case 179:
# line 432 "ansic.y"
{nesting('{');} break;
case 180:
# line 432 "ansic.y"
{nesting('}'); yyerrok; } break;
case 181:
# line 433 "ansic.y"
{ in_exp = 0; nesting('{'); } break;
case 182:
# line 433 "ansic.y"
{nesting('}');} break;
case 183:
# line 434 "ansic.y"
{nesting('{');} break;
case 184:
# line 434 "ansic.y"
{nesting('}');} break;
case 185:
# line 435 "ansic.y"
{nesting('{');} break;
case 186:
# line 435 "ansic.y"
{nesting('}');} break;
case 187:
# line 436 "ansic.y"
{nesting('{');} break;
case 188:
# line 436 "ansic.y"
{nesting('}');} break;
case 189:
# line 437 "ansic.y"
{nesting('{');} break;
case 190:
# line 437 "ansic.y"
{nesting('}');} break;
case 191:
# line 438 "ansic.y"
{nesting('{');} break;
case 192:
# line 438 "ansic.y"
{nesting('}');} break;
case 193:
# line 439 "ansic.y"
{nesting('{');} break;
case 194:
# line 439 "ansic.y"
{nesting('}');} break;
case 195:
# line 440 "ansic.y"
{nesting('{');} break;
case 196:
# line 440 "ansic.y"
{nesting('}');} break;
case 197:
# line 442 "ansic.y"
{ ERROR("iteration_statement: WHILE error statement"); } break;
case 198:
# line 444 "ansic.y"
{ ERROR("iteration_statement: DO error "); } break;
case 199:
# line 446 "ansic.y"
{ yyerrok; ERROR("iteration_statement: DO statement WHILE error ;"); } break;
case 200:
# line 448 "ansic.y"
{ ERROR("iteration_statement: FOR error statement"); } break;
case 201:
# line 453 "ansic.y"
{ yyerrok; } break;
case 202:
# line 455 "ansic.y"
{ yyerrok; } break;
case 203:
# line 457 "ansic.y"
{ yyerrok; } break;
case 204:
# line 459 "ansic.y"
{ yyerrok; } break;
case 205:
# line 461 "ansic.y"
{ yyerrok; } break;
case 206:
# line 463 "ansic.y"
{ ERROR("jump_statement: GOTO error"); } break;
case 207:
# line 465 "ansic.y"
{ ERROR("jump_statement: CONTINUE error"); } break;
case 208:
# line 467 "ansic.y"
{ ERROR("jump_statement: BREAK error"); } break;
case 209:
# line 469 "ansic.y"
{ ERROR("jump_statement: RETURN error ;"); } break;
case 212:
# line 476 "ansic.y"
{ ERROR("expression: expression , error"); } break;
case 215:
# line 483 "ansic.y"
{ ERROR("assignment_expression: unary_expression assignment_operator error"); } break;
case 217:
# line 488 "ansic.y"
{ initialize_id(); } break;
case 220:
# line 495 "ansic.y"
{ ERROR("conditional_expression: logical_or_expression '?' error ':' conditional_expression"); } break;
case 221:
# line 497 "ansic.y"
{ ERROR("conditional_expression: logical_or_expression '?' expression ':' error"); } break;
case 225:
# line 508 "ansic.y"
{ ERROR("logical_or_expression: logical_or_expression OR error"); } break;
case 228:
# line 515 "ansic.y"
{ ERROR("logical_and_expression: logical_and_expression AND error"); } break;
case 231:
# line 522 "ansic.y"
{ ERROR("inclusive_or_expression: inclusive_or_expression | error"); } break;
case 234:
# line 529 "ansic.y"
{ ERROR("exclusive_or_expression: exclusive_or_expression ^ error"); } break;
case 237:
# line 536 "ansic.y"
{ ERROR("and_expression: and_expression & error"); } break;
case 240:
# line 543 "ansic.y"
{ ERROR("equality_expression: equality_expression EQUALITY_OP error"); } break;
case 243:
# line 550 "ansic.y"
{ ERROR("relational_expression: relational_expression RELATIONAL_OP error"); } break;
case 246:
# line 557 "ansic.y"
{ ERROR("shift_expression: shift_expression SHIFT_OP error"); } break;
case 250:
# line 565 "ansic.y"
{ ERROR("additive_expression: additive_expression + error"); } break;
case 251:
# line 567 "ansic.y"
{ ERROR("additive_expression: additive_expression - error"); } break;
case 256:
# line 576 "ansic.y"
{ ERROR("multiplicative_expression: multiplicative_expression * error"); } break;
case 257:
# line 578 "ansic.y"
{ ERROR("multiplicative_expression: multiplicative_expression / error"); } break;
case 258:
# line 580 "ansic.y"
{ ERROR("multiplicative_expression: multiplicative_expression % error"); } break;
case 260:
# line 586 "ansic.y"
{ yyerrok; } break;
case 262:
# line 589 "ansic.y"
{ ERROR("cast_expression: ( error ) cast_expression"); } break;
case 268:
# line 599 "ansic.y"
{ yyerrok; } break;
case 269:
# line 601 "ansic.y"
{ ERROR("unary_expression: INCREMENT error"); } break;
case 270:
# line 603 "ansic.y"
{ ERROR("unary_expression: DECREMENT error"); } break;
case 271:
# line 605 "ansic.y"
{ ERROR("unary_expression: unary_operator error"); } break;
case 272:
# line 607 "ansic.y"
{ ERROR("unary_expression: SIZEOF error"); } break;
case 273:
# line 609 "ansic.y"
{ ERROR("unary_expression: SIZEOF (error)"); } break;
case 281:
# line 624 "ansic.y"
{ yyerrok; } break;
case 282:
# line 626 "ansic.y"
{ yyerrok; } break;
case 283:
# line 628 "ansic.y"
{ yyerrok; } break;
case 284:
# line 630 "ansic.y"
{ /* PWO */ add_to_list(); yyerrok; } break;
case 285:
# line 632 "ansic.y"
{ /* PWO */ add_to_list(); yyerrok; } break;
case 286:
# line 634 "ansic.y"
{ yyerrok; } break;
case 287:
# line 636 "ansic.y"
{ yyerrok; } break;
case 288:
# line 638 "ansic.y"
{ ERROR("postfix_expression: postfix_expression [error"); } break;
case 289:
# line 640 "ansic.y"
{ ERROR("postfix_expression: postfix_expression [expression error"); } break;
case 290:
# line 642 "ansic.y"
{ ERROR("postfix_expression: postfix_expression (error"); } break;
case 291:
# line 644 "ansic.y"
{ ERROR("postfix_expression: postfix_expression (argument_expression_list error"); } break;
case 292:
# line 646 "ansic.y"
{ ERROR("postfix_expression: postfix_expression.error"); } break;
case 293:
# line 648 "ansic.y"
{ ERROR("postfix_expression: postfix_expression->error"); } break;
case 294:
# line 652 "ansic.y"
{ add_to_list(); } break;
case 297:
# line 656 "ansic.y"
{ yyerrok; } break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

