#include "struct.h"
#include "fproto.h"

void get_prn_offset(FILE *prnfl)
{
   extern EffortNum,VgNum,StmtsNum,CmntsNum;
   char charbuf[10]={' '};
   char linebuf[BUFSIZ]={' '};
   int pos=0;
   int i=0;
   int ptr=0;  
   int firstime=1;
   int cmtfound=0;
   int skipline=0;
   extern int cmtflg;
   fpos_t *flptr;
   long fpos=0;

   flptr = &fpos;

   for (i=0;i < BUFSIZ;i++)
      linebuf[i] = ' ';
   fgets(linebuf,BUFSIZ,prnfl);
   
   while (linebuf[ptr] != '\n' && ptr < BUFSIZ)
   {
      while (!isalnum(linebuf[ptr]))  ptr++;
     

      for (i=0;i< 10;i++)
	 charbuf[i] = ' ';

      i = 0;
      while (linebuf[ptr] != '"')
      {

	 if (isalnum(linebuf[ptr]) && i < 10)
	 {
	    charbuf[i] = linebuf[ptr];
	    i++;
         }

	 ptr++;
      }
      

      if (firstime)
      {
	 printf("%s",charbuf);
	 if (strncmp(charbuf,"Proc",strlen("Proc")) != 0)
	 {
	    err_msg_disp("No Header in input file");
	    exit(1);
         }
      }
      i++;
      charbuf[i] = '\0';
      
      firstime = 0;

      if ((strncmp(charbuf,"Effort",strlen("Effort")) == 0) ||
	  (strncmp(charbuf,"E",strlen("E")) == 0))
	  {
	  EffortNum = pos; 
	  }
      else
	 if (strncmp(charbuf,"VG2",strlen("VG2")) == 0)
	 {
	    VgNum = pos;
         }
         else
	    if ((strncmp(charbuf,"Lines",strlen("Lines")) == 0) ||
	        (strncmp(charbuf,"PSS",strlen("PSS")) == 0) ||
	        (strncmp(charbuf,"LOC",strlen("LOC")) == 0))
		{
		StmtsNum = pos;
		}
            else
	       if ((strncmp(charbuf,"Comments",strlen("Comments")) == 0) ||
		   (strncmp(charbuf,"CMT",strlen("CMT")) == 0))
		  {
		     CmntsNum = pos;
		     cmtfound = 1;
	          } 
     pos++;
  }

  if (!cmtfound)
  {
     cmtflg = 0;
     CmntsNum = 0;
  }
  else
     cmtflg = 1;

  fgetpos(prnfl,flptr);

  fgets(linebuf,BUFSIZ,prnfl);
  ptr = 1;

  while (linebuf[ptr] != '"' && linebuf[ptr] == '-')
  {
     ptr++;
     skipline = 1;
  }

  if (!skipline)
     fsetpos(prnfl,flptr);
}
